import ctypes
import ctypes.util

_libmy = ctypes.CDLL("libmy.so.1")
_libc = ctypes.CDLL(ctypes.util.find_library("c"))
_sizeof_pointer = ctypes.sizeof(ctypes.c_void_p)


def getlist():
    arr = _libmy.getlist()
    ret = []
    off = 0
    p = ctypes.c_int.from_address(arr).value
    while p:
        ret.append(ctypes.string_at(p))
        _libc.free(p)
        off += _sizeof_pointer
        p = ctypes.c_int.from_address(arr + off).value
    _libc.free(arr)
    return ret

if __name__ == "__main__":
    print getlist()
